MCP Tools Reference: oracledatabase.googleapis.com

Tool: create_autonomous_database

Create an Autonomous Database (ADB). This request can be used to create a new ADB instance or a clone of an existing ADB or an ADB Disaster Recovery (DR) instance. If the source config is not specified, a new ADB instance is created. If the source config is specified, a clone of the source is created. If the source is specified and the source is an ADB DR instance, then a new ADB DR instance is created. While creating a new ADB instance, it can have Public IP support or Private IP support. In case of Private IP support, the request should contain the ODBSubnetwork details. If a request is Public IP mLTS is required mandatorily. To enable local (in-region) Data Guard for Disaster Recovery, set local_data_guard_enabled to true. You can also specify the maximum data loss limit in seconds using local_adg_auto_failover_max_data_loss_limit_duration.

The following code sample shows how to use curl to call the create_autonomous_database MCP tool.

Curl Request
curl --location 'https://oracledatabase.googleapis.com/mcp' \
--header 'content-type: application/json' \
--header 'accept: application/json, text/event-stream' \
--data '{
  "method": "tools/call",
  "params": {
    "name": "create_autonomous_database",
    "arguments": {
      // Provide these details according to the MCP tool specification.
    }
  },
  "jsonrpc": "2.0",
  "id": 1
}'

Input Schema

Request message for CreateAutonomousDatabase.

CreateAutonomousDatabaseRequest

JSON representation
{
  "parent": string,
  "autonomousDatabase": {
    object (AutonomousDatabase)
  },
  "autonomousDatabaseId": string
}
Fields
parent

string

Required. The resource name of the project to create the ADB in. Format: projects/{project}/locations/{location}

autonomousDatabase

object (AutonomousDatabase)

Required. The ADB to create.

autonomousDatabaseId

string

Required. The ID to use for the ADB that is being created.

AutonomousDatabase

JSON representation
{
  "name": string,
  "database": string,
  "displayName": string,
  "adminPasswordSecretVersion": string,
  "odbSubnet": string,
  "sourceConfig": {
    object (SourceConfig)
  },
  "computeCount": number,
  "dataStorageSizeTb": integer,
  "dataStorageSizeGb": integer,
  "dbWorkload": enum (DBWorkload),
  "dbEdition": enum (DatabaseEdition),
  "characterSet": string,
  "nCharacterSet": string,
  "dbVersion": string,
  "isAutoScalingEnabled": boolean,
  "isStorageAutoScalingEnabled": boolean,
  "licenseType": enum (LicenseType),
  "mtlsConnectionRequired": boolean,

  // Union field _local_data_guard_enabled can be only one of the following:
  "localDataGuardEnabled": boolean
  // End of list of possible types for union field _local_data_guard_enabled.

  // Union field _local_adg_auto_failover_max_data_loss_limit_duration can be
  // only one of the following:
  "localAdgAutoFailoverMaxDataLossLimitDuration": integer
  // End of list of possible types for union field
  // _local_adg_auto_failover_max_data_loss_limit_duration.

  // Union field _refreshable_clone can be only one of the following:
  "refreshableClone": boolean
  // End of list of possible types for union field _refreshable_clone.
}
Fields
name

string

Required. Identifier. The resource name of the ADB. Format: projects/{project}/locations/{location}/autonomousDatabases/{autonomous_database}

database

string

Optional. Immutable. The name of the Autonomous Database. The database name must be unique in the project. The name must begin with a letter and can contain a maximum of 30 alphanumeric characters.

displayName

string

Optional. Immutable. The display name for the Autonomous Database. The name does not have to be unique within your project.

adminPasswordSecretVersion

string

Optional. Immutable. The resource name of a secret version in Secret Manager which contains the database admin user's password. Format: projects/{project}/secrets/{secret}/versions/{version}.

odbSubnet

string

Optional. Immutable. The name of the OdbSubnet associated with the Autonomous Database. Format: projects/{project}/locations/{location}/odbNetworks/{odb_network}/odbSubnets/{odb_subnet}

sourceConfig

object (SourceConfig)

Optional. Immutable. The source Autonomous Database configuration for the standby Autonomous Database. The source Autonomous Database is configured while creating the Peer Autonomous Database or a clone and can't be updated after creation.

computeCount

number

Optional. Immutable. The number of compute servers for the Autonomous Database.

dataStorageSizeTb

integer

Optional. Immutable. The size of the data stored in the database, in terabytes.

dataStorageSizeGb

integer

Optional. Immutable. The size of the data stored in the database, in gigabytes.

dbWorkload

enum (DBWorkload)

Optional. Immutable. The workload type of the Autonomous Database.

dbEdition

enum (DatabaseEdition)

Optional. Immutable. The edition of the Autonomous Databases.

characterSet

string

Optional. Immutable. The character set for the Autonomous Database. The default is AL32UTF8.

nCharacterSet

string

Optional. Immutable. The national character set for the Autonomous Database. The default is AL16UTF16.

dbVersion

string

Optional. Immutable. The Oracle Database version for the Autonomous Database.

isAutoScalingEnabled

boolean

Optional. Immutable. This field indicates if auto scaling is enabled for the Autonomous Database CPU core count.

isStorageAutoScalingEnabled

boolean

Optional. Immutable. This field indicates if auto scaling is enabled for the Autonomous Database storage.

licenseType

enum (LicenseType)

Required. Immutable. The license type used for the Autonomous Database.

mtlsConnectionRequired

boolean

Optional. Immutable. This field specifies if the Autonomous Database requires mTLS connections.

Union field _local_data_guard_enabled.

_local_data_guard_enabled can be only one of the following:

localDataGuardEnabled

boolean

Optional. Indicates whether the Autonomous Database has a local (in-region) standby database. Not applicable to cross-region Data Guard or dedicated Exadata infrastructure.

Union field _local_adg_auto_failover_max_data_loss_limit_duration.

_local_adg_auto_failover_max_data_loss_limit_duration can be only one of the following:

localAdgAutoFailoverMaxDataLossLimitDuration

integer

Optional. This field indicates the maximum data loss limit for an Autonomous Database, in seconds.

Union field _refreshable_clone.

_refreshable_clone can be only one of the following:

refreshableClone

boolean

Optional. Indicates if the Autonomous Database is a refreshable clone. This field is used in update flow to connect / disconnect a refreshable clone from its source database.

SourceConfig

JSON representation
{
  "autonomousDatabase": string,
  "automaticBackupsReplicationEnabled": boolean,
  "sourceType": enum (SourceType),
  "cloneType": enum (CloneType),
  "refreshableMode": enum (RefreshableMode),
  "autoRefreshFrequencySeconds": integer,
  "autoRefreshStartTime": string,
  "autonomousDatabaseBackup": string,
  "backupTime": string,
  "useLatestAvailableBackup": boolean,

  // Union field _auto_refresh_point_lag_seconds can be only one of the
  // following:
  "autoRefreshPointLagSeconds": integer
  // End of list of possible types for union field
  // _auto_refresh_point_lag_seconds.
}
Fields
autonomousDatabase

string

Optional. The name of the primary Autonomous Database that is used to create a Peer Autonomous Database from a source.

automaticBackupsReplicationEnabled

boolean

Optional. This field specifies if the replication of automatic backups is enabled when creating a Data Guard.

sourceType

enum (SourceType)

Optional. The source type of the Autonomous Database.

cloneType

enum (CloneType)

Optional. The clone type of the Autonomous Database. This field is only applicable in case of cloning

refreshableMode

enum (RefreshableMode)

Optional. The refresh mode of the clone.

autoRefreshFrequencySeconds

integer

Optional. The frequency in seconds a refreshable clone is refreshed after auto-refresh is enabled.

autoRefreshStartTime

string (Timestamp format)

Optional. The date and time that auto-refreshing will begin for an Autonomous Database refreshable clone. This value controls only the start time for the first refresh operation.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

autonomousDatabaseBackup

string

Optional. The name of the Autonomous Database Backup resource with the format: projects/{project}/locations/{region}/autonomousDatabaseBackups/{autonomous_database_backup} Required when source_type is BACKUP_FROM_ID.

backupTime

string (Timestamp format)

Optional. The timestamp specified for the point-in-time clone of the source Autonomous Database. This field is only applicable in case of BACKUP_FROM_TIMESTAMP source type and when use_latest_available_backup is false.

Uses RFC 3339, where generated output will always be Z-normalized and use 0, 3, 6 or 9 fractional digits. Offsets other than "Z" are also accepted. Examples: "2014-10-02T15:01:23Z", "2014-10-02T15:01:23.045123456Z" or "2014-10-02T15:01:23+05:30".

useLatestAvailableBackup

boolean

Optional. Clone from latest available backup timestamp. This field is only applicable in case of BACKUP_FROM_TIMESTAMP source type.

Union field _auto_refresh_point_lag_seconds.

_auto_refresh_point_lag_seconds can be only one of the following:

autoRefreshPointLagSeconds

integer

Optional. The time, in seconds, the data of the automatic refreshable clone lags the primary database at the point of refresh.

Timestamp

JSON representation
{
  "seconds": string,
  "nanos": integer
}
Fields
seconds

string (int64 format)

Represents seconds of UTC time since Unix epoch 1970-01-01T00:00:00Z. Must be between -62135596800 and 253402300799 inclusive (which corresponds to 0001-01-01T00:00:00Z to 9999-12-31T23:59:59Z).

nanos

integer

Non-negative fractions of a second at nanosecond resolution. This field is the nanosecond portion of the duration, not an alternative to seconds. Negative second values with fractions must still have non-negative nanos values that count forward in time. Must be between 0 and 999,999,999 inclusive.

SourceType

Specifies the source of the database. For example, a clone or peer from an existing database. This enum may be expanded to include other source types in the future.

Enums
SOURCE_TYPE_UNSPECIFIED Default unspecified value.
CLONE_DATABASE Clone database from an existing database specified in autonomous_database field.
CROSS_REGION_DISASTER_RECOVERY Create a cross-region disaster recovery peer adb from an existing adb.
CLONE_TO_REFRESHABLE Create a refreshable clone from an existing database specified in autonomous_database field.
BACKUP_FROM_ID Create clone from the backup resource.
BACKUP_FROM_TIMESTAMP Create clone from backup specified by backup_time field, or use latest available backup if use_latest_available_backup is true. The autonomous_database field must specify the source database to clone from.

CloneType

The clone type of the Autonomous Database.

Enums
CLONE_TYPE_UNSPECIFIED Default unspecified value.
FULL Creates a new database with the source database's data and metadata.
METADATA Creates a new database that includes all the source database schema metadata, but none of the source database data.

RefreshableMode

The refresh mode of a refreshable clone.

Enums
REFRESHABLE_MODE_UNSPECIFIED Default unspecified value.
AUTOMATIC Automatic refresh.
MANUAL Manual refresh.

DBWorkload

The various states available for the Autonomous Database workload type.

Enums
DB_WORKLOAD_UNSPECIFIED Default unspecified value.
OLTP Autonomous Transaction Processing database.
DW Autonomous Data Warehouse database.
AJD Autonomous JSON Database.
APEX Autonomous Database with the Oracle APEX Application Development workload type.

DatabaseEdition

The editions available for the Autonomous Database.

Enums
DATABASE_EDITION_UNSPECIFIED Default unspecified value.
STANDARD_EDITION Standard Database Edition
ENTERPRISE_EDITION Enterprise Database Edition

LicenseType

The license types available for the Autonomous Database.

Enums
LICENSE_TYPE_UNSPECIFIED Unspecified
LICENSE_INCLUDED License included part of offer
BRING_YOUR_OWN_LICENSE Bring your own license

Output Schema

This resource represents a long-running operation that is the result of a network API call.

Operation

JSON representation
{
  "name": string,
  "metadata": {
    "@type": string,
    field1: ...,
    ...
  },
  "done": boolean,

  // Union field result can be only one of the following:
  "error": {
    object (Status)
  },
  "response": {
    "@type": string,
    field1: ...,
    ...
  }
  // End of list of possible types for union field result.
}
Fields
name

string

The server-assigned name, which is only unique within the same service that originally returns it. If you use the default HTTP mapping, the name should be a resource name ending with operations/{unique_id}.

metadata

object

Service-specific metadata associated with the operation. It typically contains progress information and common metadata such as create time. Some services might not provide such metadata. Any method that returns a long-running operation should document the metadata type, if any.

An object containing fields of an arbitrary type. An additional field "@type" contains a URI identifying the type. Example: { "id": 1234, "@type": "types.example.com/standard/id" }.

done

boolean

If the value is false, it means the operation is still in progress. If true, the operation is completed, and either error or response is available.

Union field result. The operation result, which can be either an error or a valid response. If done == false, neither error nor response is set. If done == true, exactly one of error or response can be set. Some services might not provide the result. result can be only one of the following:
error

object (Status)

The error result of the operation in case of failure or cancellation.

response

object

The normal, successful response of the operation. If the original method returns no data on success, such as Delete, the response is google.protobuf.Empty. If the original method is standard Get/Create/Update, the response should be the resource. For other methods, the response should have the type XxxResponse, where Xxx is the original method name. For example, if the original method name is TakeSnapshot(), the inferred response type is TakeSnapshotResponse.

An object containing fields of an arbitrary type. An additional field "@type" contains a URI identifying the type. Example: { "id": 1234, "@type": "types.example.com/standard/id" }.

Any

JSON representation
{
  "typeUrl": string,
  "value": string
}
Fields
typeUrl

string

Identifies the type of the serialized Protobuf message with a URI reference consisting of a prefix ending in a slash and the fully-qualified type name.

Example: type.googleapis.com/google.protobuf.StringValue

This string must contain at least one / character, and the content after the last / must be the fully-qualified name of the type in canonical form, without a leading dot. Do not write a scheme on these URI references so that clients do not attempt to contact them.

The prefix is arbitrary and Protobuf implementations are expected to simply strip off everything up to and including the last / to identify the type. type.googleapis.com/ is a common default prefix that some legacy implementations require. This prefix does not indicate the origin of the type, and URIs containing it are not expected to respond to any requests.

All type URL strings must be legal URI references with the additional restriction (for the text format) that the content of the reference must consist only of alphanumeric characters, percent-encoded escapes, and characters in the following set (not including the outer backticks): /-.~_!$&()*+,;=. Despite our allowing percent encodings, implementations should not unescape them to prevent confusion with existing parsers. For example, type.googleapis.com%2FFoo should be rejected.

In the original design of Any, the possibility of launching a type resolution service at these type URLs was considered but Protobuf never implemented one and considers contacting these URLs to be problematic and a potential security issue. Do not attempt to contact type URLs.

value

string (bytes format)

Holds a Protobuf serialization of the type described by type_url.

A base64-encoded string.

Status

JSON representation
{
  "code": integer,
  "message": string,
  "details": [
    {
      "@type": string,
      field1: ...,
      ...
    }
  ]
}
Fields
code

integer

The status code, which should be an enum value of google.rpc.Code.

message

string

A developer-facing error message, which should be in English. Any user-facing error message should be localized and sent in the google.rpc.Status.details field, or localized by the client.

details[]

object

A list of messages that carry the error details. There is a common set of message types for APIs to use.

An object containing fields of an arbitrary type. An additional field "@type" contains a URI identifying the type. Example: { "id": 1234, "@type": "types.example.com/standard/id" }.

Tool Annotations

Tool annotations are sent to MCP clients to describe the basic risk of a given tool. Most clients treat these hints as untrusted, but they can be used to decide when a confirmation prompt might be sent to a user.

Along with the title string, the following boolean hints are defined as follows:

  • readOnlyHint: If true, the tool doesn't modify its environment. Default: false.
  • destructiveHint: If true, then the tool can perform destructive actions. If false, then the tool can only perform additive actions. Default: true.
  • idempotentHint: If true, then calling the tool repeatedly with the same arguments will have no additional effect on its environment. Default: false.
  • openWorldHint: If true, then the tool can interact with an 'open world' of external entities. If false, then the tool can only interact with internal entities. For example, a web search tool would be open world, while a memory tool would not be open world.

Destructive Hint: ❌ | Idempotent Hint: ❌ | Read Only Hint: ❌ | Open World Hint: ❌